import 'package:algolia/algolia.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:pc_plugins/controllers/suggestion/temp_config.dart';

import '../../custom_exception.dart';
import '../../model/algolia_filter_providers.dart';
import '../config_template.dart';

final suggestionLoadingPvd=AutoDisposeStateProviderFamily<bool,String>((ref, roles) => false);

class suggestionsController_temp<T> extends StateNotifier<List<T>>{
  final Ref ref;
  final String? myId;
  final sug_tempConfig<T> config;
  String lastSearch="";

  suggestionsController_temp(this.ref,this.myId,{required this.config}) : super([]);

  void setDialog(String s){
    if(config.dialogC!=null)
      ref.read(config.dialogC!.notifier).update((state) => s);
  }
  void setExDialog(CustomException e){
    if(config.exDialogC!=null)
      ref.read(config.exDialogC!.notifier).update((state) => e);
  }

  Future<void> search(String q,{int? lmt,List<String>? more=const []})async{
    lastSearch=q;
    if(ref.read(suggestionLoadingPvd(config.pageid)))return;
    ref.read(suggestionLoadingPvd(config.pageid).notifier).state=true;

    if(q.isEmpty){
      state=[];
      ref.read(suggestionLoadingPvd(config.pageid).notifier).state=false;
      return;
    }

    final filters=ref.read(algoFiltersPvd(config.pageid)).values.map((e) => e.function).toList();

    try{
      final snaps=config.customSearchFunc!=null?
      await config.customSearchFunc!(q,ref, page: 0,
          hperp: lmt??config.defaultPSize, containID: myId,filters: filters,
          attributes:config.attributesAlgo..addAll(more??[])):
      await ref.read(config.dataSrcPvd).searchT_algo(q,containID: myId,
          filters: filters, page: 0,hperp: lmt??config.defaultPSize,
          attributes:config.attributesAlgo..addAll(more??[]));
      ref.read(suggestionLoadingPvd(config.pageid).notifier).state=false;

      if(q==lastSearch){ state = snaps.data;}
      else{ search(lastSearch);}
    }on CustomException catch(e,st){
      ref.read(suggestionLoadingPvd(config.pageid).notifier).state=false;
      setExDialog(e);
    }
  }

  void dismiss(){
    ref.read(suggestionLoadingPvd(config.pageid).notifier).state=false;
    state.clear();
  }
}