import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'package:pointer_interceptor/pointer_interceptor.dart';
import 'dart:io' show Platform;

init({required String url,double width=90,double height=100,
  void Function()? onTap,bool interactive=false}) {
  // InkWell(onTap: onTap,child:Container(width: width, height: height, color: Colors.transparent,
  //     child: const Center(child: Icon(Icons.file_open))),);


  // if (Platform.isAndroid) {
  //   return InkWell(onTap: onTap,child:Container(width: width, height: height, color: Colors.transparent,
  //       child: const Center(child: Icon(Icons.file_open))),);
  // } else if (Platform.isIOS) {
    // iOS-specific code
    return PdfPreview(
      url: url, width: width,height: height,onTap: onTap,interactive: interactive,);
  // }
}

class PdfPreview extends StatefulWidget {
  final String url;
  final double width;
  final double height;
  final bool loading;
  final void Function()? onTap;
  final bool interactive;
  final bool border;


  PdfPreview({
    required this.url,
    this.width = 200,
    this.height = 200,
    this.loading = false,
    this.interactive = false,
    this.onTap,
    this.border = false,

  });

  @override
  _PdfPreviewState createState() => _PdfPreviewState();
}

class _PdfPreviewState extends State<PdfPreview> {
  Color backgroundColor = Colors.transparent;
  late WebViewController _controller;

  initState() async {
    super.initState();
    _controller = WebViewController()
      ..setJavaScriptMode(JavaScriptMode.unrestricted)
      ..setBackgroundColor(const Color(0x00000000))
      ..setNavigationDelegate(
        NavigationDelegate(
          onWebResourceError: (WebResourceError error) {
          },
          onNavigationRequest: (NavigationRequest request) {
            return NavigationDecision.navigate;
          },
        ),
      );
    return _controller.loadRequest(Uri.parse(widget.url));
  }

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: widget.width,
      height: widget.height,
      child: Stack(
        children: [
          WebViewWidget(
                  controller: _controller,
                ),
          if (!widget.interactive)
            PointerInterceptor(
              child: SizedBox(
                width: widget.width,
                height: widget.height,
                child: ElevatedButton(
                  onPressed: widget.onTap,
                  style: ElevatedButton.styleFrom(
                    backgroundColor: Colors.transparent,
                    elevation: 0,
                  ),
                  child: null,
                ),
              ),
            ),
        ],
      ),
    );
  }
}