import 'dart:html';
import 'package:flutter/material.dart';
import 'dart:ui' as ui;
import 'package:pointer_interceptor/pointer_interceptor.dart';


init({required String url,double width=90,double height=100,
  void Function()? onTap,bool interactive=false}) =>
    // InkWell(onTap: onTap,child:Container(width: width, height: height, color: Colors.transparent,
    //     child: const Center(child: Icon(Icons.file_open))),);
PdfPreview(
  url: url, width: width,height: height,onTap: onTap,interactive: interactive,);

class PdfPreview extends StatefulWidget{
  final String url;
  final double width;
  final double height;
  final void Function()? onTap;
  final bool interactive;

  const PdfPreview({super.key,
    required this.url,
    this.width = 90,
    this.height = 100,
    this.interactive = false,
    this.onTap,
  });

  @override
  _PdfPreviewState createState() => _PdfPreviewState();
}



class _PdfPreviewState extends State<PdfPreview> {
  Color backgroundColor = Colors.transparent;

  @override
  void initState() {
    super.initState();
    ui.platformViewRegistry.registerViewFactory(
      widget.url,
          (int viewId) {
        IFrameElement iframe = IFrameElement()
          ..width = widget.width.toString()
          ..height = widget.height.toString()
          ..src = widget.url;

        if (!widget.interactive) {
          iframe
            ..style.pointerEvents = 'none'
            ..style.overflow = 'hidden';
        }

        return iframe;
      },
    );
  }


  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: widget.width,
      height: widget.height,
      child: Stack(
        children: [
          HtmlElementView(viewType: widget.url),
          if (!widget.interactive)
            PointerInterceptor(
                child: InkWell(onTap: widget.onTap,
                // ElevatedButton(
                //   onPressed: widget.onTap,
                //   style: ElevatedButton.styleFrom(
                //     backgroundColor: Colors.transparent,
                //     elevation: 0,
                //   ),
                //   child: null,
                // ),
              ),
            ),
        ],
      ),
    );
  }

}