import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:pc_plugins/widgets/site_preview/site_preview_default.dart';

void main() {
  group('site_preview', () {
    testWidgets('PdfPreview widget', (WidgetTester tester) async {
      // Mock the loadingBuilder function
      Widget loadingWidget() {
        return const CircularProgressIndicator();
      }

      await tester.pumpWidget(MaterialApp(
        home: Scaffold(
          body: Center(
            child: SitePreview(
              url:
              'https://res.cloudinary.com/hamlet78/image/upload/v1678149966/trustUs/Adriana%20Cendejas/ts/2023-03-06/Notary%20Fee%202.pdf.pdf',
              width: 100,
              height: 100,
              loading: true,
              interactive: true,
              onTap: () async {
                print("Tapped");

              },
              border: false,
              loadingBuilder: loadingWidget,
            ),
          ),
        ),
      ));


    });
  });
}
